/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2009                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#ifndef OBITTABLEIDI_BANDPASS_H 
#define OBITTABLEIDI_BANDPASS_H 

#include "Obit.h"
#include "ObitErr.h"
#include "ObitTable.h"
#include "ObitData.h"

/*-------- Obit: Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableIDI_BANDPASS.h
 * ObitTableIDI_BANDPASS class definition.
 *
 * This class is derived from the #ObitTable class.
 *
 * This class contains tabular data and allows access.
 * This table is part of the IDI uv data format.
 * "IDI\_BANDPASS" contains bandpass calibration data.
 * Only FITS cataloged data are supported.
 * This class is derived from the ObitTable class.
 *
 * This class contains tabular data and allows access.
 * "IDI_BANDPASS" table
 * An ObitTableIDI_BANDPASS is the front end to a persistent disk resident structure.
 * Only FITS (as Tables) are supported.
 *
 * \section TableDataStorage Table data storage
 * In memory tables are stored in a fashion similar to how they are 
 * stored on disk - in large blocks in memory rather than structures.
 * Due to the word alignment requirements of some machines, they are 
 * stored by order of the decreasing element size: 
 * double, float long, int, short, char rather than the logical order.
 * The details of the storage in the buffer are kept in the 
 * #ObitTableIDI_BANDPASSDesc.
 *
 * In addition to the normal tabular data, a table will have a "_status"
 * column to indicate the status of each row.
 *
 * \section ObitTableIDI_BANDPASSSpecification Specifying desired data transfer parameters
 * The desired data transfers are specified in the member ObitInfoList.
 * In the following an ObitInfoList entry is defined by 
 * the name in double quotes, the data type code as an #ObitInfoType enum 
 * and the dimensions of the array (? => depends on application).
 *
 * The following apply to both types of files:
 * \li "nRowPIO", OBIT_int, Max. Number of visibilities per 
 *     "Read" or "Write" operation.  Default = 1.
 *
 * \subsection TableFITS FITS files
 * This implementation uses cfitsio which allows using, in addition to 
 * regular FITS images, gzip compressed files, pipes, shared memory 
 * and a number of other input forms.
 * The convenience Macro #ObitTableIDI_BANDPASSSetFITS simplifies specifying the 
 * desired data.
 * Binary tables are used for storing visibility data in FITS.
 * For accessing FITS files the following entries in the ObitInfoList 
 * are used:
 * \li "FileName" OBIT_string (?,1,1) FITS file name.
 * \li "TabName"  OBIT_string (?,1,1) Table name (e.g. "AIPS CC").
 * \li "Ver"      OBIT_int    (1,1,1) Table version number
 *
 *
 * \section ObitTableIDI_BANDPASSaccess Creators and Destructors
 * An ObitTableIDI_BANDPASS can be created using newObitTableIDI_BANDPASSValue which attaches the 
 * table to an ObitData for the object.  
 * If the output ObitTableIDI_BANDPASS has previously been specified, including file information,
 * then ObitTableIDI_BANDPASSCopy will copy the disk resident as well as the memory 
 * resident information.
 *
 * A copy of a pointer to an ObitTableIDI_BANDPASS should always be made using the
 * ObitTableIDI_BANDPASSRef function which updates the reference count in the object.
 * Then whenever freeing an ObitTableIDI_BANDPASS or changing a pointer, the function
 * ObitTableIDI_BANDPASSUnref will decrement the reference count and destroy the object
 * when the reference count hits 0.
 *
 * \section ObitTableIDI_BANDPASSUsage I/O
 * Visibility data is available after an input object is "Opened"
 * and "Read".
 * I/O optionally uses a buffer attached to the ObitTableIDI_BANDPASS or some external
 * location.
 * To Write an ObitTableIDI_BANDPASS, create it, open it, and write.
 * The object should be closed to ensure all data is flushed to disk.
 * Deletion of an ObitTableIDI_BANDPASS after its final unreferencing will automatically
 * close it.
 */

/*--------------Class definitions-------------------------------------*/

/** Number of characters for Table keyword */
 #define MAXKEYCHARTABLEIDI_BANDPASS 24

/** ObitTableIDI_BANDPASS Class structure. */
typedef struct {
#include "ObitTableIDI_BANDPASSDef.h"   /* this class definition */
} ObitTableIDI_BANDPASS;

/** ObitTableIDI_BANDPASSRow Class structure. */
typedef struct {
#include "ObitTableIDI_BANDPASSRowDef.h"   /* this class row definition */
} ObitTableIDI_BANDPASSRow;

/*----------------- Macroes ---------------------------*/
/** 
 * Macro to unreference (and possibly destroy) an ObitTableIDI_BANDPASS
 * returns an ObitTableIDI_BANDPASS*.
 * in = object to unreference
 */
#define ObitTableIDI_BANDPASSUnref(in) ObitUnref (in)

/** 
 * Macro to reference (update reference count) an ObitTableIDI_BANDPASS.
 * returns an ObitTableIDI_BANDPASS*.
 * in = object to reference
 */
#define ObitTableIDI_BANDPASSRef(in) ObitRef (in)

/** 
 * Macro to determine if an object is the member of this or a 
 * derived class.
 * Returns TRUE if a member, else FALSE
 * in = object to reference
 */
#define ObitTableIDI_BANDPASSIsA(in) ObitIsA (in, ObitTableIDI_BANDPASSGetClass())

/** 
 * Macro to unreference (and possibly destroy) an ObitTableIDI_BANDPASSRow
 * returns an ObitTableIDI_BANDPASSRow*.
 * in = object to unreference
 */
#define ObitTableIDI_BANDPASSRowUnref(in) ObitUnref (in)

/** 
 * Macro to reference (update reference count) an ObitTableIDI_BANDPASSRow.
 * returns an ObitTableIDI_BANDPASSRow*.
 * in = object to reference
 */
#define ObitTableIDI_BANDPASSRowRef(in) ObitRef (in)

/** 
 * Macro to determine if an object is the member of this or a 
 * derived class.
 * Returns TRUE if a member, else FALSE
 * in = object to reference
 */
#define ObitTableIDI_BANDPASSRowIsA(in) ObitIsA (in, ObitTableIDI_BANDPASSRowGetClass())

/*---------------Public functions---------------------------*/
/*----------------Table Row Functions ----------------------*/
/** Public: Row Class initializer. */
void ObitTableIDI_BANDPASSRowClassInit (void);

/** Public: Constructor. */
ObitTableIDI_BANDPASSRow* newObitTableIDI_BANDPASSRow (ObitTableIDI_BANDPASS *table);

/** Public: ClassInfo pointer */
gconstpointer ObitTableIDI_BANDPASSRowGetClass (void);

/*------------------Table Functions ------------------------*/
/** Public: Class initializer. */
void ObitTableIDI_BANDPASSClassInit (void);

/** Public: Constructor. */
ObitTableIDI_BANDPASS* newObitTableIDI_BANDPASS (gchar* name);

/** Public: Constructor from values. */
ObitTableIDI_BANDPASS* 
newObitTableIDI_BANDPASSValue (gchar* name, ObitData *file, olong *ver,
  		     ObitIOAccess access,
                     oint numPol, oint no_band, oint numAnt, oint numBach, oint strtChn,
		     ObitErr *err);

/** Public: Class initializer. */
void ObitTableIDI_BANDPASSClassInit (void);

/** Public: ClassInfo pointer */
gconstpointer ObitTableIDI_BANDPASSGetClass (void);

/** Public: Copy (deep) constructor. */
ObitTableIDI_BANDPASS* ObitTableIDI_BANDPASSCopy  (ObitTableIDI_BANDPASS *in, ObitTableIDI_BANDPASS *out, 
			   ObitErr *err);

/** Public: Copy (shallow) constructor. */
ObitTableIDI_BANDPASS* ObitTableIDI_BANDPASSClone (ObitTableIDI_BANDPASS *in, ObitTableIDI_BANDPASS *out);

/** Public: Convert an ObitTable to an ObitTableIDI_BANDPASS */
ObitTableIDI_BANDPASS* ObitTableIDI_BANDPASSConvert  (ObitTable *in);

/** Public: Create ObitIO structures and open file */
ObitIOCode ObitTableIDI_BANDPASSOpen (ObitTableIDI_BANDPASS *in, ObitIOAccess access, 
			  ObitErr *err);

/** Public: Read a table row */
ObitIOCode 
ObitTableIDI_BANDPASSReadRow  (ObitTableIDI_BANDPASS *in, olong iIDI_BANDPASSRow, ObitTableIDI_BANDPASSRow *row,
		     ObitErr *err);

/** Public: Init a table row for write */
void 
ObitTableIDI_BANDPASSSetRow  (ObitTableIDI_BANDPASS *in, ObitTableIDI_BANDPASSRow *row,
		     ObitErr *err);

/** Public: Write a table row */
ObitIOCode 
ObitTableIDI_BANDPASSWriteRow  (ObitTableIDI_BANDPASS *in, olong iIDI_BANDPASSRow, ObitTableIDI_BANDPASSRow *row,
		     ObitErr *err);

/** Public: Close file and become inactive */
ObitIOCode ObitTableIDI_BANDPASSClose (ObitTableIDI_BANDPASS *in, ObitErr *err);

/*----------- ClassInfo Structure -----------------------------------*/
/**
 * ClassInfo Structure.
 * Contains class name, a pointer to any parent class
 * (NULL if none) and function pointers.
 */
typedef struct  {
#include "ObitTableIDI_BANDPASSClassDef.h"
} ObitTableIDI_BANDPASSClassInfo; 

/**
 * ClassInfo Structure For TableIDI_BANDPASSRow.
 * Contains class name, a pointer to any parent class
 * (NULL if none) and function pointers.
 */
typedef struct  {
#include "ObitTableIDI_BANDPASSRowClassDef.h"
} ObitTableIDI_BANDPASSRowClassInfo; 
#endif /* OBITTABLEIDI_BANDPASS_H */ 
