/* $Id: TableIDI_UV_DATA.inc 123 2009-09-04 11:26:14Z bill.cotton $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2009                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
%{
#include "Obit.h"
#include "ObitData.h"
#include "ObitTableIDI_UV_DATA.h"
%}
 
%inline %{
 
extern ObitTable* TableIDI_UV_DATA (ObitData *inData, long *tabVer,
 	                   int access,
 	                   char *tabName,
                           int no_band, int maxis1, int maxis2, int maxis3, int maxis4, int maxis5,
                           ObitErr *err)
 {
   ObitIOAccess laccess;
   /* Cast structural keywords to correct type */
   oint lno_band = (oint)no_band;
   oint lmaxis1 = (oint)maxis1;
   oint lmaxis2 = (oint)maxis2;
   oint lmaxis3 = (oint)maxis3;
   oint lmaxis4 = (oint)maxis4;
   oint lmaxis5 = (oint)maxis5;
   olong ltabVer = (olong)*tabVer;
   ObitTable *outTable=NULL;
   laccess = OBIT_IO_ReadOnly;
   if (access==2) laccess = OBIT_IO_WriteOnly;
   else if (access==3) laccess = OBIT_IO_ReadWrite;
   outTable = (ObitTable*)newObitTableIDI_UV_DATAValue ((gchar*)tabName, inData, (olong*)&ltabVer,
   			   laccess, 
                           lno_band, lmaxis1, lmaxis2, lmaxis3, lmaxis4, lmaxis5,
                           err);
   *tabVer = (long)ltabVer;
   return outTable;
   }
 
extern PyObject* TableIDI_UV_DATAGetHeadKeys (ObitTable *inTab) {
  PyObject *outDict=PyDict_New();
  ObitTableIDI_UV_DATA *lTab = (ObitTableIDI_UV_DATA*)inTab;
  PyDict_SetItemString(outDict, "no_band",  PyInt_FromLong((long)lTab->no_band));
  PyDict_SetItemString(outDict, "maxis1",  PyInt_FromLong((long)lTab->maxis1));
  PyDict_SetItemString(outDict, "maxis2",  PyInt_FromLong((long)lTab->maxis2));
  PyDict_SetItemString(outDict, "maxis3",  PyInt_FromLong((long)lTab->maxis3));
  PyDict_SetItemString(outDict, "maxis4",  PyInt_FromLong((long)lTab->maxis4));
  PyDict_SetItemString(outDict, "maxis5",  PyInt_FromLong((long)lTab->maxis5));
  PyDict_SetItemString(outDict, "tabrev",  PyInt_FromLong((long)lTab->tabrev));
  PyDict_SetItemString(outDict, "no_stkd",  PyInt_FromLong((long)lTab->no_stkd));
  PyDict_SetItemString(outDict, "stk_1",  PyInt_FromLong((long)lTab->stk_1));
  PyDict_SetItemString(outDict, "no_chan",  PyInt_FromLong((long)lTab->no_chan));
  PyDict_SetItemString(outDict, "ref_freq",  PyFloat_FromDouble((double)lTab->ref_freq));
  PyDict_SetItemString(outDict, "chan_bw",  PyFloat_FromDouble((double)lTab->chan_bw));
  PyDict_SetItemString(outDict, "ref_pixl",  PyInt_FromLong((long)lTab->ref_pixl));
  PyDict_SetItemString(outDict, "obscode", PyString_InternFromString(lTab->obscode));
  PyDict_SetItemString(outDict, "RefDate", PyString_InternFromString(lTab->RefDate));
  PyDict_SetItemString(outDict, "nmatrix",  PyInt_FromLong((long)lTab->nmatrix));
  PyDict_SetItemString(outDict, "maxis",  PyInt_FromLong((long)lTab->maxis));
  PyDict_SetItemString(outDict, "Equinox", PyString_InternFromString(lTab->Equinox));
  PyDict_SetItemString(outDict, "WeighTyp", PyString_InternFromString(lTab->WeighTyp));
 PyDict_SetItemString(outDict, "tmatx01",  PyInt_FromLong((long)lTab->tmatx01));
 PyDict_SetItemString(outDict, "tmatx02",  PyInt_FromLong((long)lTab->tmatx02));
 PyDict_SetItemString(outDict, "tmatx03",  PyInt_FromLong((long)lTab->tmatx03));
 PyDict_SetItemString(outDict, "tmatx04",  PyInt_FromLong((long)lTab->tmatx04));
 PyDict_SetItemString(outDict, "tmatx05",  PyInt_FromLong((long)lTab->tmatx05));
 PyDict_SetItemString(outDict, "tmatx06",  PyInt_FromLong((long)lTab->tmatx06));
 PyDict_SetItemString(outDict, "tmatx07",  PyInt_FromLong((long)lTab->tmatx07));
 PyDict_SetItemString(outDict, "tmatx08",  PyInt_FromLong((long)lTab->tmatx08));
 PyDict_SetItemString(outDict, "tmatx09",  PyInt_FromLong((long)lTab->tmatx09));
 PyDict_SetItemString(outDict, "tmatx10",  PyInt_FromLong((long)lTab->tmatx10));
 PyDict_SetItemString(outDict, "tmatx11",  PyInt_FromLong((long)lTab->tmatx11));
 PyDict_SetItemString(outDict, "tmatx12",  PyInt_FromLong((long)lTab->tmatx12));
 PyDict_SetItemString(outDict, "tmatx13",  PyInt_FromLong((long)lTab->tmatx13));
 PyDict_SetItemString(outDict, "tmatx14",  PyInt_FromLong((long)lTab->tmatx14));
 PyDict_SetItemString(outDict, "tmatx15",  PyInt_FromLong((long)lTab->tmatx15));
  PyDict_SetItemString(outDict, "cdelt1",  PyFloat_FromDouble((double)lTab->cdelt1));
  PyDict_SetItemString(outDict, "crpix1",  PyFloat_FromDouble((double)lTab->crpix1));
  PyDict_SetItemString(outDict, "crval1",  PyFloat_FromDouble((double)lTab->crval1));
  PyDict_SetItemString(outDict, "cdelt2",  PyFloat_FromDouble((double)lTab->cdelt2));
  PyDict_SetItemString(outDict, "crpix2",  PyFloat_FromDouble((double)lTab->crpix2));
  PyDict_SetItemString(outDict, "crval2",  PyFloat_FromDouble((double)lTab->crval2));
  PyDict_SetItemString(outDict, "cdelt3",  PyFloat_FromDouble((double)lTab->cdelt3));
  PyDict_SetItemString(outDict, "crpix3",  PyFloat_FromDouble((double)lTab->crpix3));
  PyDict_SetItemString(outDict, "crval3",  PyFloat_FromDouble((double)lTab->crval3));
  PyDict_SetItemString(outDict, "cdelt4",  PyFloat_FromDouble((double)lTab->cdelt4));
  PyDict_SetItemString(outDict, "crpix4",  PyFloat_FromDouble((double)lTab->crpix4));
  PyDict_SetItemString(outDict, "crval4",  PyFloat_FromDouble((double)lTab->crval4));
  PyDict_SetItemString(outDict, "cdelt5",  PyFloat_FromDouble((double)lTab->cdelt5));
  PyDict_SetItemString(outDict, "crpix5",  PyFloat_FromDouble((double)lTab->crpix5));
  PyDict_SetItemString(outDict, "crval5",  PyFloat_FromDouble((double)lTab->crval5));
  PyDict_SetItemString(outDict, "maxis6",  PyInt_FromLong((long)lTab->maxis6));
  PyDict_SetItemString(outDict, "cdelt6",  PyFloat_FromDouble((double)lTab->cdelt6));
  PyDict_SetItemString(outDict, "crpix6",  PyFloat_FromDouble((double)lTab->crpix6));
  PyDict_SetItemString(outDict, "crval6",  PyFloat_FromDouble((double)lTab->crval6));
  PyDict_SetItemString(outDict, "maxis7",  PyInt_FromLong((long)lTab->maxis7));
  PyDict_SetItemString(outDict, "cdelt7",  PyFloat_FromDouble((double)lTab->cdelt7));
  PyDict_SetItemString(outDict, "crpix7",  PyFloat_FromDouble((double)lTab->crpix7));
  PyDict_SetItemString(outDict, "crval7",  PyFloat_FromDouble((double)lTab->crval7));
  PyDict_SetItemString(outDict, "dateObs", PyString_InternFromString(lTab->dateObs));
  PyDict_SetItemString(outDict, "visScale",  PyFloat_FromDouble((double)lTab->visScale));

  return outDict;
} 

extern void TableIDI_UV_DATASetHeadKeys (ObitTable *inTab, PyObject *inDict) {
  ObitTableIDI_UV_DATA *lTab = (ObitTableIDI_UV_DATA*)inTab;
  char *tstr;
  int lstr=MAXKEYCHARTABLEIDI_UV_DATA;

  lTab->tabrev = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tabrev"));
  lTab->no_stkd = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "no_stkd"));
  lTab->stk_1 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "stk_1"));
  lTab->no_chan = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "no_chan"));
  lTab->ref_freq = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "ref_freq"));
  lTab->chan_bw = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "chan_bw"));
  lTab->ref_pixl = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "ref_pixl"));
  tstr = PyString_AsString(PyDict_GetItemString(inDict, "obscode"));
  strncpy (lTab->obscode, tstr, lstr); lTab->obscode[lstr-1]=0;
  tstr = PyString_AsString(PyDict_GetItemString(inDict, "RefDate"));
  strncpy (lTab->RefDate, tstr, lstr); lTab->RefDate[lstr-1]=0;
  lTab->nmatrix = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "nmatrix"));
  lTab->maxis = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "maxis"));
  tstr = PyString_AsString(PyDict_GetItemString(inDict, "Equinox"));
  strncpy (lTab->Equinox, tstr, lstr); lTab->Equinox[lstr-1]=0;
  tstr = PyString_AsString(PyDict_GetItemString(inDict, "WeighTyp"));
  strncpy (lTab->WeighTyp, tstr, lstr); lTab->WeighTyp[lstr-1]=0;
  lTab->tmatx01 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tmatx01"));
  lTab->tmatx02 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tmatx02"));
  lTab->tmatx03 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tmatx03"));
  lTab->tmatx04 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tmatx04"));
  lTab->tmatx05 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tmatx05"));
  lTab->tmatx06 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tmatx06"));
  lTab->tmatx07 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tmatx07"));
  lTab->tmatx08 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tmatx08"));
  lTab->tmatx09 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tmatx09"));
  lTab->tmatx10 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tmatx10"));
  lTab->tmatx11 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tmatx11"));
  lTab->tmatx12 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tmatx12"));
  lTab->tmatx13 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tmatx13"));
  lTab->tmatx14 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tmatx14"));
  lTab->tmatx15 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "tmatx15"));
  lTab->cdelt1 = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "cdelt1"));
  lTab->crpix1 = (ofloat)PyFloat_AsDouble(PyDict_GetItemString(inDict, "crpix1"));
  lTab->crval1 = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "crval1"));
  lTab->cdelt2 = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "cdelt2"));
  lTab->crpix2 = (ofloat)PyFloat_AsDouble(PyDict_GetItemString(inDict, "crpix2"));
  lTab->crval2 = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "crval2"));
  lTab->cdelt3 = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "cdelt3"));
  lTab->crpix3 = (ofloat)PyFloat_AsDouble(PyDict_GetItemString(inDict, "crpix3"));
  lTab->crval3 = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "crval3"));
  lTab->cdelt4 = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "cdelt4"));
  lTab->crpix4 = (ofloat)PyFloat_AsDouble(PyDict_GetItemString(inDict, "crpix4"));
  lTab->crval4 = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "crval4"));
  lTab->cdelt5 = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "cdelt5"));
  lTab->crpix5 = (ofloat)PyFloat_AsDouble(PyDict_GetItemString(inDict, "crpix5"));
  lTab->crval5 = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "crval5"));
  lTab->maxis6 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "maxis6"));
  lTab->cdelt6 = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "cdelt6"));
  lTab->crpix6 = (ofloat)PyFloat_AsDouble(PyDict_GetItemString(inDict, "crpix6"));
  lTab->crval6 = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "crval6"));
  lTab->maxis7 = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "maxis7"));
  lTab->cdelt7 = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "cdelt7"));
  lTab->crpix7 = (ofloat)PyFloat_AsDouble(PyDict_GetItemString(inDict, "crpix7"));
  lTab->crval7 = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "crval7"));
  tstr = PyString_AsString(PyDict_GetItemString(inDict, "dateObs"));
  strncpy (lTab->dateObs, tstr, lstr); lTab->dateObs[lstr-1]=0;
  lTab->visScale = (ofloat)PyFloat_AsDouble(PyDict_GetItemString(inDict, "visScale"));

  if ((lTab->myDesc->access==OBIT_IO_ReadWrite) || (lTab->myDesc->access==OBIT_IO_WriteOnly)) 
    lTab->myStatus = OBIT_Modified;
} 

%}
