/* $Id: TableSU.inc 123 2009-09-04 11:26:14Z bill.cotton $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2009                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
%{
#include "Obit.h"
#include "ObitData.h"
#include "ObitTableSU.h"
%}
 
%inline %{
 
extern ObitTable* TableSU (ObitData *inData, long *tabVer,
 	                   int access,
 	                   char *tabName,
                           int numIF,
                           ObitErr *err)
 {
   ObitIOAccess laccess;
   /* Cast structural keywords to correct type */
   oint lnumIF = (oint)numIF;
   olong ltabVer = (olong)*tabVer;
   ObitTable *outTable=NULL;
   laccess = OBIT_IO_ReadOnly;
   if (access==2) laccess = OBIT_IO_WriteOnly;
   else if (access==3) laccess = OBIT_IO_ReadWrite;
   outTable = (ObitTable*)newObitTableSUValue ((gchar*)tabName, inData, (olong*)&ltabVer,
   			   laccess, 
                           lnumIF,
                           err);
   *tabVer = (long)ltabVer;
   return outTable;
   }
 
extern PyObject* TableSUGetHeadKeys (ObitTable *inTab) {
  PyObject *outDict=PyDict_New();
  ObitTableSU *lTab = (ObitTableSU*)inTab;
  PyDict_SetItemString(outDict, "numIF",  PyInt_FromLong((long)lTab->numIF));
  PyDict_SetItemString(outDict, "velType", PyString_InternFromString(lTab->velType));
  PyDict_SetItemString(outDict, "velDef", PyString_InternFromString(lTab->velDef));
  PyDict_SetItemString(outDict, "FreqID",  PyInt_FromLong((long)lTab->FreqID));

  return outDict;
} 

extern void TableSUSetHeadKeys (ObitTable *inTab, PyObject *inDict) {
  ObitTableSU *lTab = (ObitTableSU*)inTab;
  char *tstr;
  int lstr=MAXKEYCHARTABLESU;

  tstr = PyString_AsString(PyDict_GetItemString(inDict, "velType"));
  strncpy (lTab->velType, tstr, lstr); lTab->velType[lstr-1]=0;
  tstr = PyString_AsString(PyDict_GetItemString(inDict, "velDef"));
  strncpy (lTab->velDef, tstr, lstr); lTab->velDef[lstr-1]=0;
  lTab->FreqID = (oint)PyInt_AsLong(PyDict_GetItemString(inDict, "FreqID"));

  if ((lTab->myDesc->access==OBIT_IO_ReadWrite) || (lTab->myDesc->access==OBIT_IO_WriteOnly)) 
    lTab->myStatus = OBIT_Modified;
} 

%}
