/* $Id: ObitTableAT.c 128 2009-09-23 14:48:29Z bill.cotton $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2009                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableAT.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableAT.c
 * ObitTableAT class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableAT";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableATRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableATRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableATClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableATClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableATRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableATRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableATInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableATClear (gpointer in);

/** Private: update table specific info */
static void ObitTableATUpdate (ObitTableAT *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableATDumpKey (ObitTableAT *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableATClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableATRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableATRow* newObitTableATRow (ObitTableAT *table)
{
  ObitTableATRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableATRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableATRow));

  /* initialize values */
  out->name = g_strdup("TableAT Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableATRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    out->AntName = cRow + table->AntNameOff;
    out->PolAngA = fRow + table->PolAngAOff;
    out->PolCalA = fRow + table->PolCalAOff;
    out->PolAngB = fRow + table->PolAngBOff;
    out->PolCalB = fRow + table->PolCalBOff;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableATRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableATRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableATRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableATRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableAT* newObitTableAT (gchar* name)
{
  ObitTableAT* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableATClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableAT));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableATInit((gpointer)out);

 return out;
} /* end newObitTableAT */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableATGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableATClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitATGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param numBand The number of Bands(?).
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableAT* newObitTableATValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint numBand,
		     ObitErr *err)
{
  ObitTableAT* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS AT";
  gchar *routine = "newObitTableATValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableATClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS AT");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableAT */
      if (ObitTableATIsA(testTab)) { /* it is an ObitTableAT */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableATConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS AT");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableATIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableATConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->numBand = MAX (0, numBand);
  out->revision = 3;
  strncpy (out->obscode, "AA000", MAXKEYCHARTABLEAT );
  strncpy (out->RefDate, "YYYY-MM-DD", MAXKEYCHARTABLEAT );
  strncpy (out->polType, "APPROX  ", MAXKEYCHARTABLEAT );
  out->FreqID = 0;

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 12 + out->numBand*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("TIME    ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("TIME_INTERVAL ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((8 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("ANNAME  ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 8;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("ANTENNA_NO");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ARRAY      ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("NO_LEVELS");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("POLTYA  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_string;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((numBand > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("POLAA   ");
    desc->FieldUnit[colNo] = g_strdup("DEGREES");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  optional = FALSE;
  if ((numBand > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("POLCALA");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("POLTYB ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_string;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((numBand > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("POLAB  ");
    desc->FieldUnit[colNo] = g_strdup("DEGREES");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  optional = FALSE;
  if ((numBand > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("POLCALB");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableATDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableATOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableATClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableATValue */

/**
 * Convert an ObitTable to an ObitTableAT.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableAT* ObitTableATConvert (ObitTable* in)
{
  ObitTableAT *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableAT(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableATConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableAT* ObitTableATCopy (ObitTableAT *in, ObitTableAT *out, ObitErr *err)
{
  gchar *routine = "ObitTableATCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableATClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableAT*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->revision = in->revision;
  strncpy (out->obscode, in->obscode, MAXKEYCHARTABLEAT );
  strncpy (out->RefDate, in->RefDate, MAXKEYCHARTABLEAT );
  out->numStkd = in->numStkd;
  out->stk1 = in->stk1;
  out->numBand = in->numBand;
  out->numChan = in->numChan;
  out->refFreq = in->refFreq;
  out->chanBW = in->chanBW;
  out->refPixl = in->refPixl;
  out->noPCal = in->noPCal;
  strncpy (out->polType, in->polType, MAXKEYCHARTABLEAT );
  out->FreqID = in->FreqID;
  /* Update class specific info */
  ObitTableATUpdate (out, err);
    
  return out;
} /* end ObitTableATCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableATOpen (ObitTableAT *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableATOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableATClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableATUpdate (in, err);
   
   return retCode;
} /* end ObitTableATOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iATRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableATReadRow  (ObitTableAT *in, olong iATRow, ObitTableATRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableATReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS AT Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iATRow */
  retCode = ObitTableRead ((ObitTable*)in, iATRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->Time = dRow[in->TimeOff];
  row->TimeI = fRow[in->TimeIOff];
  row->antennaNo = iRow[in->antennaNoOff];
  row->Array = iRow[in->ArrayOff];
  row->numLevels = iRow[in->numLevelsOff];
  row->polTypeA = cRow[in->polTypeAOff];
  row->polTypeB = cRow[in->polTypeBOff];
  row->AntName = cRow + in->AntNameOff;
  row->PolAngA = fRow + in->PolAngAOff;
  row->PolCalA = fRow + in->PolCalAOff;
  row->PolAngB = fRow + in->PolAngBOff;
  row->PolCalB = fRow + in->PolCalBOff;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableATReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableATSetRow  (ObitTableAT *in, ObitTableATRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AT Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  row->AntName = cRow + in->AntNameOff;
  row->PolAngA = fRow + in->PolAngAOff;
  row->PolCalA = fRow + in->PolCalAOff;
  row->PolAngB = fRow + in->PolAngBOff;
  row->PolCalB = fRow + in->PolCalBOff;

} /*  end ObitTableATSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableATSetRow  
 * \param in       Table to read
 * \param iATRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableATWriteRow  (ObitTableAT *in, olong iATRow, ObitTableATRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableATWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS AT Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  dRow[in->TimeOff] = row->Time;
  fRow[in->TimeIOff] = row->TimeI;
  iRow[in->antennaNoOff] = row->antennaNo;
  iRow[in->ArrayOff] = row->Array;
  iRow[in->numLevelsOff] = row->numLevels;
  cRow[in->polTypeAOff] = row->polTypeA;
  cRow[in->polTypeBOff] = row->polTypeB;
  if (in->AntNameCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->AntNameCol]; i++) 
      cRow[in->AntNameOff+i] = row->AntName[i];
  } 
  if (in->PolAngACol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->PolAngACol]; i++) 
      fRow[in->PolAngAOff+i] = row->PolAngA[i];
  } 
  if (in->PolCalACol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->PolCalACol]; i++) 
      fRow[in->PolCalAOff+i] = row->PolCalA[i];
  } 
  if (in->PolAngBCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->PolAngBCol]; i++) 
      fRow[in->PolAngBOff+i] = row->PolAngB[i];
  } 
  if (in->PolCalBCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->PolCalBCol]; i++) 
      fRow[in->PolCalBOff+i] = row->PolCalB[i];
  } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iATRow */
  retCode = ObitTableWrite ((ObitTable*)in, iATRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableATWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableATClose (ObitTableAT *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableATClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableATDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableATClose */

/*---------------Private functions--------------------------*/
/*----------------  TableAT Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableATRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableATRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->AntName = NULL;
  in->PolAngA = NULL;
  in->PolCalA = NULL;
  in->PolAngB = NULL;
  in->PolCalB = NULL;

} /* end ObitTableATRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableATRow* cast to an Obit*.
 */
void ObitTableATRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableATRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableATRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableATRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableATRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableATRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableATRowClassInfoDefFn (gpointer inClass)
{
  ObitTableATRowClassInfo *theClass = (ObitTableATRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableATRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableATRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableATRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableATRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableATRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableATRowInit;

} /* end ObitTableATRowClassDefFn */

/*------------------  TableAT  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableATInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableAT *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableATInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableAT* cast to an Obit*.
 */
void ObitTableATClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableAT *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableATClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableATClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableATClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableATClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableATClassInfoDefFn (gpointer inClass)
{
  ObitTableATClassInfo *theClass = (ObitTableATClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableATClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableATClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableATGetClass;
  theClass->newObit       = (newObitFP)newObitTableAT;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableATCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableATClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableATInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableATConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableATOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableATClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableATReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableATWriteRow;

} /* end ObitTableATClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableATUpdate (ObitTableAT *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   union ObitInfoListEquiv InfoReal; 

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* revision */
  in->revision = 3; 
  ObitInfoListGetTest(in->myDesc->info, "TABREV", &type, dim, 
		       (gpointer)&in->revision);
   /* obscode */
  strncpy (in->obscode, "AA000", MAXKEYCHARTABLEAT); 
  ObitInfoListGetTest(in->myDesc->info, "OBSCODE", &type, dim, 
		       (gpointer)&in->obscode);
   /* RefDate */
  strncpy (in->RefDate, "YYYY-MM-DD", MAXKEYCHARTABLEAT); 
  ObitInfoListGetTest(in->myDesc->info, "RDATE", &type, dim, 
		       (gpointer)&in->RefDate);
   /* numStkd */
  if (!ObitInfoListGet(in->myDesc->info, "NO_STKD", &type, dim, 
		       (gpointer)&in->numStkd, err)) return;
   /* stk1 */
  if (!ObitInfoListGet(in->myDesc->info, "STK_1", &type, dim, 
		       (gpointer)&in->stk1, err)) return;
   /* numBand */
  if (!ObitInfoListGet(in->myDesc->info, "NO_BAND", &type, dim, 
		       (gpointer)&in->numBand, err)) return;
   /* numChan */
  if (!ObitInfoListGet(in->myDesc->info, "NO_CHAN", &type, dim, 
		       (gpointer)&in->numChan, err)) return;
   /* refFreq */
  if (!ObitInfoListGet(in->myDesc->info, "REF_FREQ", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->refFreq = InfoReal.dbl;
  if (type==OBIT_float)  in->refFreq = InfoReal.flt;
   /* chanBW */
  if (!ObitInfoListGet(in->myDesc->info, "CHAN_BW", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->chanBW = InfoReal.dbl;
  if (type==OBIT_float)  in->chanBW = InfoReal.flt;
   /* refPixl */
  if (!ObitInfoListGet(in->myDesc->info, "REF_PIXL", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->refPixl = InfoReal.dbl;
  if (type==OBIT_float)  in->refPixl = InfoReal.flt;
   /* noPCal */
  if (!ObitInfoListGet(in->myDesc->info, "NOPCAL", &type, dim, 
		       (gpointer)&in->noPCal, err)) return;
   /* polType */
  strncpy (in->polType, "APPROX  ", MAXKEYCHARTABLEAT); 
  ObitInfoListGetTest(in->myDesc->info, "POLTYPE", &type, dim, 
		       (gpointer)&in->polType);
   /* FreqID */
  in->FreqID = 0; 
  ObitInfoListGetTest(in->myDesc->info, "FREQID", &type, dim, 
		       (gpointer)&in->FreqID);

  /* initialize column numbers/offsets */
  in->TimeOff = -1;
  in->TimeCol = -1;
  in->TimeIOff = -1;
  in->TimeICol = -1;
  in->AntNameOff = -1;
  in->AntNameCol = -1;
  in->antennaNoOff = -1;
  in->antennaNoCol = -1;
  in->ArrayOff = -1;
  in->ArrayCol = -1;
  in->numLevelsOff = -1;
  in->numLevelsCol = -1;
  in->polTypeAOff = -1;
  in->polTypeACol = -1;
  in->PolAngAOff = -1;
  in->PolAngACol = -1;
  in->PolCalAOff = -1;
  in->PolCalACol = -1;
  in->polTypeBOff = -1;
  in->polTypeBCol = -1;
  in->PolAngBOff = -1;
  in->PolAngBCol = -1;
  in->PolCalBOff = -1;
  in->PolCalBCol = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "TIME    ", 8)) {
	 in->TimeOff = desc->offset[i];
 	 in->TimeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TIME_INTERVAL ", 14)) {
	 in->TimeIOff = desc->offset[i];
 	 in->TimeICol = i;
      }
      if (!strncmp (desc->FieldName[i], "ANNAME  ", 8)) {
	 in->AntNameOff = desc->offset[i];
 	 in->AntNameCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ANTENNA_NO", 10)) {
	 in->antennaNoOff = desc->offset[i];
 	 in->antennaNoCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ARRAY      ", 11)) {
	 in->ArrayOff = desc->offset[i];
 	 in->ArrayCol = i;
      }
      if (!strncmp (desc->FieldName[i], "NO_LEVELS", 9)) {
	 in->numLevelsOff = desc->offset[i];
 	 in->numLevelsCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLTYA  ", 8)) {
	 in->polTypeAOff = desc->offset[i];
 	 in->polTypeACol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLAA   ", 8)) {
	 in->PolAngAOff = desc->offset[i];
 	 in->PolAngACol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLCALA", 7)) {
	 in->PolCalAOff = desc->offset[i];
 	 in->PolCalACol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLTYB ", 7)) {
	 in->polTypeBOff = desc->offset[i];
 	 in->polTypeBCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLAB  ", 7)) {
	 in->PolAngBOff = desc->offset[i];
 	 in->PolAngBCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLCALB", 7)) {
	 in->PolCalBOff = desc->offset[i];
 	 in->PolCalBCol = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->TimeOff > -1), err,
       "ObitTableATUpdate: Could not find column Time");
  Obit_return_if_fail((in->TimeIOff > -1), err,
       "ObitTableATUpdate: Could not find column TimeI");
  Obit_return_if_fail((in->AntNameOff > -1), err,
       "ObitTableATUpdate: Could not find column AntName");
  Obit_return_if_fail((in->antennaNoOff > -1), err,
       "ObitTableATUpdate: Could not find column antennaNo");
  Obit_return_if_fail((in->ArrayOff > -1), err,
       "ObitTableATUpdate: Could not find column Array");
  Obit_return_if_fail((in->numLevelsOff > -1), err,
       "ObitTableATUpdate: Could not find column numLevels");
  Obit_return_if_fail((in->polTypeAOff > -1), err,
       "ObitTableATUpdate: Could not find column polTypeA");
  Obit_return_if_fail((in->PolAngAOff > -1), err,
       "ObitTableATUpdate: Could not find column PolAngA");
  Obit_return_if_fail((in->PolCalAOff > -1), err,
       "ObitTableATUpdate: Could not find column PolCalA");
  Obit_return_if_fail((in->polTypeBOff > -1), err,
       "ObitTableATUpdate: Could not find column polTypeB");
  Obit_return_if_fail((in->PolAngBOff > -1), err,
       "ObitTableATUpdate: Could not find column PolAngB");
} /* end ObitTableATUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableATDumpKey (ObitTableAT *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
  else info = in->myDesc->info;
  /* revision */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TABREV", type, dim, 
		  (gpointer)&in->revision);
  /* obscode */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEAT;
  ObitInfoListAlwaysPut(info, "OBSCODE", type, dim, 
		  (gpointer)&in->obscode);
  /* RefDate */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEAT;
  ObitInfoListAlwaysPut(info, "RDATE", type, dim, 
		  (gpointer)&in->RefDate);
  /* numStkd */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_STKD", type, dim, 
		  (gpointer)&in->numStkd);
  /* stk1 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "STK_1", type, dim, 
		  (gpointer)&in->stk1);
  /* numBand */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_BAND", type, dim, 
		  (gpointer)&in->numBand);
  /* numChan */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_CHAN", type, dim, 
		  (gpointer)&in->numChan);
  /* refFreq */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_FREQ", type, dim, 
		  (gpointer)&in->refFreq);
  /* chanBW */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CHAN_BW", type, dim, 
		  (gpointer)&in->chanBW);
  /* refPixl */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_PIXL", type, dim, 
		  (gpointer)&in->refPixl);
  /* noPCal */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NOPCAL", type, dim, 
		  (gpointer)&in->noPCal);
  /* polType */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEAT;
  ObitInfoListAlwaysPut(info, "POLTYPE", type, dim, 
		  (gpointer)&in->polType);
  /* FreqID */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "FREQID", type, dim, 
		  (gpointer)&in->FreqID);
   
} /* end ObitTableATDumpKey */
