/* $Id: ObitTableIDI_FREQUENCY.c 190 2010-05-04 15:21:06Z bill.cotton $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2010                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableIDI_FREQUENCY.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableIDI_FREQUENCY.c
 * ObitTableIDI_FREQUENCY class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableIDI_FREQUENCY";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableIDI_FREQUENCYRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIDI_FREQUENCYRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableIDI_FREQUENCYClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIDI_FREQUENCYClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableIDI_FREQUENCYRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableIDI_FREQUENCYRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableIDI_FREQUENCYInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableIDI_FREQUENCYClear (gpointer in);

/** Private: update table specific info */
static void ObitTableIDI_FREQUENCYUpdate (ObitTableIDI_FREQUENCY *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableIDI_FREQUENCYDumpKey (ObitTableIDI_FREQUENCY *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableIDI_FREQUENCYClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableIDI_FREQUENCYRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIDI_FREQUENCYRow* newObitTableIDI_FREQUENCYRow (ObitTableIDI_FREQUENCY *table)
{
  ObitTableIDI_FREQUENCYRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIDI_FREQUENCYRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIDI_FREQUENCYRow));

  /* initialize values */
  out->name = g_strdup("TableIDI_FREQUENCY Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableIDI_FREQUENCYRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    out->bandfreq = dRow + table->bandfreqOff;
    out->chWidth = fRow + table->chWidthOff;
    out->totBW = fRow + table->totBWOff;
    out->sideBand = iRow + table->sideBandOff;
    out->bb_chan = iRow + table->bb_chanOff;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableIDI_FREQUENCYRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableIDI_FREQUENCYRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIDI_FREQUENCYRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableIDI_FREQUENCYRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIDI_FREQUENCY* newObitTableIDI_FREQUENCY (gchar* name)
{
  ObitTableIDI_FREQUENCY* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_FREQUENCYClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIDI_FREQUENCY));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableIDI_FREQUENCYInit((gpointer)out);

 return out;
} /* end newObitTableIDI_FREQUENCY */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableIDI_FREQUENCYGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_FREQUENCYClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitIDI_FREQUENCYGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param no_band Number of frequency bands
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableIDI_FREQUENCY* newObitTableIDI_FREQUENCYValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint no_band,
		     ObitErr *err)
{
  ObitTableIDI_FREQUENCY* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "FREQUENCY";
  gchar *routine = "newObitTableIDI_FREQUENCYValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_FREQUENCYClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "FREQUENCY");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableIDI_FREQUENCY */
      if (ObitTableIDI_FREQUENCYIsA(testTab)) { /* it is an ObitTableIDI_FREQUENCY */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableIDI_FREQUENCYConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "FREQUENCY");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableIDI_FREQUENCYIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableIDI_FREQUENCYConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->no_band = MAX (0, no_band);
  out->tabrev = 1;
  out->no_stkd = 1;
  out->stk_1 = -1;
  out->no_chan = 1;
  out->ref_freq = 1.0;
  out->chan_bw = 1.0;
  out->ref_pixl = 1.0;
  strncpy (out->obscode, "    ", MAXKEYCHARTABLEIDI_FREQUENCY );
  strncpy (out->RefDate, "YYYY-MM-DD", MAXKEYCHARTABLEIDI_FREQUENCY );

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 6 + out->no_band*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("FREQID  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("BANDFREQ");
    desc->FieldUnit[colNo] = g_strdup("HZ");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("CH_WIDTH");
    desc->FieldUnit[colNo] = g_strdup("HZ");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("TOTAL_BANDWIDTH ");
    desc->FieldUnit[colNo] = g_strdup("HZ");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("SIDEBAND ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("BB_CHAN ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableIDI_FREQUENCYDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableIDI_FREQUENCYOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableIDI_FREQUENCYClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableIDI_FREQUENCYValue */

/**
 * Convert an ObitTable to an ObitTableIDI_FREQUENCY.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableIDI_FREQUENCY* ObitTableIDI_FREQUENCYConvert (ObitTable* in)
{
  ObitTableIDI_FREQUENCY *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableIDI_FREQUENCY(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableIDI_FREQUENCYConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableIDI_FREQUENCY* ObitTableIDI_FREQUENCYCopy (ObitTableIDI_FREQUENCY *in, ObitTableIDI_FREQUENCY *out, ObitErr *err)
{
  gchar *routine = "ObitTableIDI_FREQUENCYCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_FREQUENCYClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableIDI_FREQUENCY*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->tabrev = in->tabrev;
  out->no_stkd = in->no_stkd;
  out->stk_1 = in->stk_1;
  out->no_band = in->no_band;
  out->no_chan = in->no_chan;
  out->ref_freq = in->ref_freq;
  out->chan_bw = in->chan_bw;
  out->ref_pixl = in->ref_pixl;
  strncpy (out->obscode, in->obscode, MAXKEYCHARTABLEIDI_FREQUENCY );
  strncpy (out->RefDate, in->RefDate, MAXKEYCHARTABLEIDI_FREQUENCY );
  /* Update class specific info */
  ObitTableIDI_FREQUENCYUpdate (out, err);
    
  return out;
} /* end ObitTableIDI_FREQUENCYCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS (AIPS not allowed) 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIDI_FREQUENCYOpen (ObitTableIDI_FREQUENCY *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableIDI_FREQUENCYOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_FREQUENCYClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableIDI_FREQUENCYUpdate (in, err);
   
   return retCode;
} /* end ObitTableIDI_FREQUENCYOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iIDI_FREQUENCYRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIDI_FREQUENCYReadRow  (ObitTableIDI_FREQUENCY *in, olong iIDI_FREQUENCYRow, ObitTableIDI_FREQUENCYRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIDI_FREQUENCYReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_FREQUENCY Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iIDI_FREQUENCYRow */
  retCode = ObitTableRead ((ObitTable*)in, iIDI_FREQUENCYRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->fqid = iRow[in->fqidOff];
  row->bandfreq = dRow + in->bandfreqOff;
  row->chWidth = fRow + in->chWidthOff;
  row->totBW = fRow + in->totBWOff;
  row->sideBand = iRow + in->sideBandOff;
  row->bb_chan = iRow + in->bb_chanOff;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableIDI_FREQUENCYReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableIDI_FREQUENCYSetRow  (ObitTableIDI_FREQUENCY *in, ObitTableIDI_FREQUENCYRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_FREQUENCY Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  row->bandfreq = dRow + in->bandfreqOff;
  row->chWidth = fRow + in->chWidthOff;
  row->totBW = fRow + in->totBWOff;
  row->sideBand = iRow + in->sideBandOff;
  row->bb_chan = iRow + in->bb_chanOff;

} /*  end ObitTableIDI_FREQUENCYSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableIDI_FREQUENCYSetRow  
 * \param in       Table to read
 * \param iIDI_FREQUENCYRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIDI_FREQUENCYWriteRow  (ObitTableIDI_FREQUENCY *in, olong iIDI_FREQUENCYRow, ObitTableIDI_FREQUENCYRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIDI_FREQUENCYWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_FREQUENCY Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  iRow[in->fqidOff] = row->fqid;
  if (in->bandfreqCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->bandfreqCol]; i++) 
      dRow[in->bandfreqOff+i] = row->bandfreq[i];
  } 
  if (in->chWidthCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->chWidthCol]; i++) 
      fRow[in->chWidthOff+i] = row->chWidth[i];
  } 
  if (in->totBWCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->totBWCol]; i++) 
      fRow[in->totBWOff+i] = row->totBW[i];
  } 
  if (in->sideBandCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->sideBandCol]; i++) 
      iRow[in->sideBandOff+i] = row->sideBand[i];
  } 
  if (in->bb_chanCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->bb_chanCol]; i++) 
      iRow[in->bb_chanOff+i] = row->bb_chan[i];
  } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iIDI_FREQUENCYRow */
  retCode = ObitTableWrite ((ObitTable*)in, iIDI_FREQUENCYRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableIDI_FREQUENCYWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIDI_FREQUENCYClose (ObitTableIDI_FREQUENCY *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableIDI_FREQUENCYClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableIDI_FREQUENCYDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableIDI_FREQUENCYClose */

/*---------------Private functions--------------------------*/
/*----------------  TableIDI_FREQUENCY Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIDI_FREQUENCYRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_FREQUENCYRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->bandfreq = NULL;
  in->chWidth = NULL;
  in->totBW = NULL;
  in->sideBand = NULL;
  in->bb_chan = NULL;

} /* end ObitTableIDI_FREQUENCYRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIDI_FREQUENCYRow* cast to an Obit*.
 */
void ObitTableIDI_FREQUENCYRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_FREQUENCYRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIDI_FREQUENCYRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIDI_FREQUENCYRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableIDI_FREQUENCYRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIDI_FREQUENCYRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIDI_FREQUENCYRowClassInfoDefFn (gpointer inClass)
{
  ObitTableIDI_FREQUENCYRowClassInfo *theClass = (ObitTableIDI_FREQUENCYRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIDI_FREQUENCYRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIDI_FREQUENCYRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIDI_FREQUENCYRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableIDI_FREQUENCYRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableIDI_FREQUENCYRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableIDI_FREQUENCYRowInit;

} /* end ObitTableIDI_FREQUENCYRowClassDefFn */

/*------------------  TableIDI_FREQUENCY  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIDI_FREQUENCYInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_FREQUENCY *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableIDI_FREQUENCYInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIDI_FREQUENCY* cast to an Obit*.
 */
void ObitTableIDI_FREQUENCYClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_FREQUENCY *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIDI_FREQUENCYClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIDI_FREQUENCYClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableIDI_FREQUENCYClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIDI_FREQUENCYClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIDI_FREQUENCYClassInfoDefFn (gpointer inClass)
{
  ObitTableIDI_FREQUENCYClassInfo *theClass = (ObitTableIDI_FREQUENCYClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIDI_FREQUENCYClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIDI_FREQUENCYClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIDI_FREQUENCYGetClass;
  theClass->newObit       = (newObitFP)newObitTableIDI_FREQUENCY;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableIDI_FREQUENCYCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableIDI_FREQUENCYClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableIDI_FREQUENCYInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableIDI_FREQUENCYConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableIDI_FREQUENCYOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableIDI_FREQUENCYClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableIDI_FREQUENCYReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableIDI_FREQUENCYWriteRow;

} /* end ObitTableIDI_FREQUENCYClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIDI_FREQUENCYUpdate (ObitTableIDI_FREQUENCY *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   union ObitInfoListEquiv InfoReal; 

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* tabrev */
  in->tabrev = 1; 
  ObitInfoListGetTest(in->myDesc->info, "TABREV", &type, dim, 
		       (gpointer)&in->tabrev);
   /* no_stkd */
  in->no_stkd = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_STKD", &type, dim, 
		       (gpointer)&in->no_stkd);
   /* stk_1 */
  in->stk_1 = -1; 
  ObitInfoListGetTest(in->myDesc->info, "STK_1", &type, dim, 
		       (gpointer)&in->stk_1);
   /* no_band */
  in->no_band = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_BAND", &type, dim, 
		       (gpointer)&in->no_band);
   /* no_chan */
  in->no_chan = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_CHAN", &type, dim, 
		       (gpointer)&in->no_chan);
  in->ref_freq = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "REF_FREQ", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->ref_freq = InfoReal.dbl;
  if (type==OBIT_float)  in->ref_freq = InfoReal.flt;
  in->chan_bw = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CHAN_BW", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->chan_bw = InfoReal.dbl;
  if (type==OBIT_float)  in->chan_bw = InfoReal.flt;
   /* ref_pixl */
  in->ref_pixl = 1.0; 
  ObitInfoListGetTest(in->myDesc->info, "REF_PIXL", &type, dim, 
		       (gpointer)&in->ref_pixl);
   /* obscode */
  strncpy (in->obscode, "    ", MAXKEYCHARTABLEIDI_FREQUENCY); 
  ObitInfoListGetTest(in->myDesc->info, "OBSCODE", &type, dim, 
		       (gpointer)&in->obscode);
   /* RefDate */
  strncpy (in->RefDate, "YYYY-MM-DD", MAXKEYCHARTABLEIDI_FREQUENCY); 
  ObitInfoListGetTest(in->myDesc->info, "RDATE", &type, dim, 
		       (gpointer)&in->RefDate);

  /* initialize column numbers/offsets */
  in->fqidOff = -1;
  in->fqidCol = -1;
  in->bandfreqOff = -1;
  in->bandfreqCol = -1;
  in->chWidthOff = -1;
  in->chWidthCol = -1;
  in->totBWOff = -1;
  in->totBWCol = -1;
  in->sideBandOff = -1;
  in->sideBandCol = -1;
  in->bb_chanOff = -1;
  in->bb_chanCol = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "FREQID  ", 8)) {
	 in->fqidOff = desc->offset[i];
 	 in->fqidCol = i;
      }
      if (!strncmp (desc->FieldName[i], "BANDFREQ", 8)) {
	 in->bandfreqOff = desc->offset[i];
 	 in->bandfreqCol = i;
      }
      if (!strncmp (desc->FieldName[i], "CH_WIDTH", 8)) {
	 in->chWidthOff = desc->offset[i];
 	 in->chWidthCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TOTAL_BANDWIDTH ", 16)) {
	 in->totBWOff = desc->offset[i];
 	 in->totBWCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SIDEBAND ", 9)) {
	 in->sideBandOff = desc->offset[i];
 	 in->sideBandCol = i;
      }
      if (!strncmp (desc->FieldName[i], "BB_CHAN ", 8)) {
	 in->bb_chanOff = desc->offset[i];
 	 in->bb_chanCol = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->fqidOff > -1), err,
       "ObitTableIDI_FREQUENCYUpdate: Could not find column fqid");
  Obit_return_if_fail((in->bandfreqOff > -1), err,
       "ObitTableIDI_FREQUENCYUpdate: Could not find column bandfreq");
  Obit_return_if_fail((in->chWidthOff > -1), err,
       "ObitTableIDI_FREQUENCYUpdate: Could not find column chWidth");
  Obit_return_if_fail((in->totBWOff > -1), err,
       "ObitTableIDI_FREQUENCYUpdate: Could not find column totBW");
  Obit_return_if_fail((in->sideBandOff > -1), err,
       "ObitTableIDI_FREQUENCYUpdate: Could not find column sideBand");
} /* end ObitTableIDI_FREQUENCYUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIDI_FREQUENCYDumpKey (ObitTableIDI_FREQUENCY *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
  else info = in->myDesc->info;
  /* tabrev */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TABREV", type, dim, 
		  (gpointer)&in->tabrev);
  /* no_stkd */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_STKD", type, dim, 
		  (gpointer)&in->no_stkd);
  /* stk_1 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "STK_1", type, dim, 
		  (gpointer)&in->stk_1);
  /* no_band */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_BAND", type, dim, 
		  (gpointer)&in->no_band);
  /* no_chan */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_CHAN", type, dim, 
		  (gpointer)&in->no_chan);
  /* ref_freq */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_FREQ", type, dim, 
		  (gpointer)&in->ref_freq);
  /* chan_bw */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CHAN_BW", type, dim, 
		  (gpointer)&in->chan_bw);
  /* ref_pixl */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_PIXL", type, dim, 
		  (gpointer)&in->ref_pixl);
  /* obscode */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_FREQUENCY;
  ObitInfoListAlwaysPut(info, "OBSCODE", type, dim, 
		  (gpointer)&in->obscode);
  /* RefDate */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_FREQUENCY;
  ObitInfoListAlwaysPut(info, "RDATE", type, dim, 
		  (gpointer)&in->RefDate);
   
} /* end ObitTableIDI_FREQUENCYDumpKey */
