/* $Id: ObitTableIM.c 128 2009-09-23 14:48:29Z bill.cotton $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2009                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableIM.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableIM.c
 * ObitTableIM class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableIM";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableIMRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIMRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableIMClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIMClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableIMRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableIMRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableIMInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableIMClear (gpointer in);

/** Private: update table specific info */
static void ObitTableIMUpdate (ObitTableIM *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableIMDumpKey (ObitTableIM *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableIMClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableIMRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIMRow* newObitTableIMRow (ObitTableIM *table)
{
  ObitTableIMRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIMRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIMRow));

  /* initialize values */
  out->name = g_strdup("TableIM Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableIMRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    out->FreqVar = fRow + table->FreqVarOff;
    if (table->numPol>=1) out->PDelay1 = dRow + table->PDelay1Off;
    if (table->numPol>=1) out->GDelay1 = dRow + table->GDelay1Off;
    if (table->numPol>=1) out->PRate1 = dRow + table->PRate1Off;
    if (table->numPol>=1) out->GRate1 = dRow + table->GRate1Off;
    if (table->numPol>=1) out->Disp1 = fRow[table->Disp1Off];
    if (table->numPol>=1) out->DRate1 = fRow[table->DRate1Off];
    if (table->numPol>=2) out->PDelay2 = dRow + table->PDelay2Off;
    if (table->numPol>=2) out->GDelay2 = dRow + table->GDelay2Off;
    if (table->numPol>=2) out->PRate2 = dRow + table->PRate2Off;
    if (table->numPol>=2) out->GRate2 = dRow + table->GRate2Off;
    if (table->numPol>=2) out->Disp2 = fRow[table->Disp2Off];
    if (table->numPol>=2) out->DRate2 = fRow[table->DRate2Off];
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableIMRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableIMRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIMRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableIMRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIM* newObitTableIM (gchar* name)
{
  ObitTableIM* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIMClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIM));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableIMInit((gpointer)out);

 return out;
} /* end newObitTableIM */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableIMGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIMClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitIMGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param numPol The number of polarizations.
 * \param numBand The number of Bands(?).
 * \param npoly The number of polynomial terms.
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableIM* newObitTableIMValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint numPol, oint numBand, oint npoly,
		     ObitErr *err)
{
  ObitTableIM* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS IM";
  gchar *routine = "newObitTableIMValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIMClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS IM");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableIM */
      if (ObitTableIMIsA(testTab)) { /* it is an ObitTableIM */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableIMConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS IM");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableIMIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableIMConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->numPol = MAX (0, numPol);
  out->numBand = MAX (0, numBand);
  out->npoly = MAX (0, npoly);
  strncpy (out->RefDate, "YYYY-MM-DD", MAXKEYCHARTABLEIM );
  strncpy (out->obscode, "AA000", MAXKEYCHARTABLEIM );
  out->tabrev = 2;
  out->revision = 1.0;

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 8 + out->numPol*6 + out->numBand*0 + out->npoly*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("TIME    ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("TIME_INTERVAL ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SOURCE_ID  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ANTENNA_NO");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ARRAY      ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("FREQID");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("I.FAR.ROT");
  desc->FieldUnit[colNo] = g_strdup("RAD/M**2");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((numBand > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("FREQ.VAR");
    desc->FieldUnit[colNo] = g_strdup("HZ");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numBand;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("PDELAY_1");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = npoly;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("GDELAY_1");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = npoly;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("PRATE_1");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = npoly;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("GRATE_1");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = npoly;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("DISP_1");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("DDISP_1");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("PDELAY_2");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = npoly;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("GDELAY_2");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = npoly;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("PRATE_2");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = npoly;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("GRATE_2");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = npoly;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("DISP_2");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("DDISP_2");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableIMDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableIMOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableIMClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableIMValue */

/**
 * Convert an ObitTable to an ObitTableIM.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableIM* ObitTableIMConvert (ObitTable* in)
{
  ObitTableIM *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableIM(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableIMConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableIM* ObitTableIMCopy (ObitTableIM *in, ObitTableIM *out, ObitErr *err)
{
  gchar *routine = "ObitTableIMCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIMClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableIM*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  strncpy (out->RefDate, in->RefDate, MAXKEYCHARTABLEIM );
  out->numPol = in->numPol;
  strncpy (out->obscode, in->obscode, MAXKEYCHARTABLEIM );
  out->numStkd = in->numStkd;
  out->numBand = in->numBand;
  out->numChan = in->numChan;
  out->refFreq = in->refFreq;
  out->chanBW = in->chanBW;
  out->refPixl = in->refPixl;
  out->npoly = in->npoly;
  out->tabrev = in->tabrev;
  out->revision = in->revision;
  /* Update class specific info */
  ObitTableIMUpdate (out, err);
    
  return out;
} /* end ObitTableIMCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIMOpen (ObitTableIM *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableIMOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIMClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableIMUpdate (in, err);
   
   return retCode;
} /* end ObitTableIMOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iIMRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIMReadRow  (ObitTableIM *in, olong iIMRow, ObitTableIMRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIMReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS IM Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iIMRow */
  retCode = ObitTableRead ((ObitTable*)in, iIMRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->Time = dRow[in->TimeOff];
  row->TimeI = fRow[in->TimeIOff];
  row->SourID = iRow[in->SourIDOff];
  row->antennaNo = iRow[in->antennaNoOff];
  row->Array = iRow[in->ArrayOff];
  row->FreqID = iRow[in->FreqIDOff];
  row->IFR = fRow[in->IFROff];
  row->FreqVar = fRow + in->FreqVarOff;
  if (in->numPol>=1) row->PDelay1 = dRow + in->PDelay1Off;
  if (in->numPol>=1) row->GDelay1 = dRow + in->GDelay1Off;
  if (in->numPol>=1) row->PRate1 = dRow + in->PRate1Off;
  if (in->numPol>=1) row->GRate1 = dRow + in->GRate1Off;
  if (in->numPol>=1) row->Disp1 = fRow[in->Disp1Off];
  if (in->numPol>=1) row->DRate1 = fRow[in->DRate1Off];
  if (in->numPol>=2) row->PDelay2 = dRow + in->PDelay2Off;
  if (in->numPol>=2) row->GDelay2 = dRow + in->GDelay2Off;
  if (in->numPol>=2) row->PRate2 = dRow + in->PRate2Off;
  if (in->numPol>=2) row->GRate2 = dRow + in->GRate2Off;
  if (in->numPol>=2) row->Disp2 = fRow[in->Disp2Off];
  if (in->numPol>=2) row->DRate2 = fRow[in->DRate2Off];
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableIMReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableIMSetRow  (ObitTableIM *in, ObitTableIMRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IM Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  row->FreqVar = fRow + in->FreqVarOff;
  if (in->numPol>=1) row->PDelay1 = dRow + in->PDelay1Off;
  if (in->numPol>=1) row->GDelay1 = dRow + in->GDelay1Off;
  if (in->numPol>=1) row->PRate1 = dRow + in->PRate1Off;
  if (in->numPol>=1) row->GRate1 = dRow + in->GRate1Off;
  if (in->numPol>=1) row->Disp1 = fRow[in->Disp1Off];
  if (in->numPol>=1) row->DRate1 = fRow[in->DRate1Off];
  if (in->numPol>=2) row->PDelay2 = dRow + in->PDelay2Off;
  if (in->numPol>=2) row->GDelay2 = dRow + in->GDelay2Off;
  if (in->numPol>=2) row->PRate2 = dRow + in->PRate2Off;
  if (in->numPol>=2) row->GRate2 = dRow + in->GRate2Off;
  if (in->numPol>=2) row->Disp2 = fRow[in->Disp2Off];
  if (in->numPol>=2) row->DRate2 = fRow[in->DRate2Off];

} /*  end ObitTableIMSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableIMSetRow  
 * \param in       Table to read
 * \param iIMRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIMWriteRow  (ObitTableIM *in, olong iIMRow, ObitTableIMRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIMWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS IM Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  dRow[in->TimeOff] = row->Time;
  fRow[in->TimeIOff] = row->TimeI;
  iRow[in->SourIDOff] = row->SourID;
  iRow[in->antennaNoOff] = row->antennaNo;
  iRow[in->ArrayOff] = row->Array;
  iRow[in->FreqIDOff] = row->FreqID;
  fRow[in->IFROff] = row->IFR;
  if (in->FreqVarCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->FreqVarCol]; i++) 
      fRow[in->FreqVarOff+i] = row->FreqVar[i];
  } 
  if (in->numPol>=1)
    if (in->PDelay1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PDelay1Col]; i++) 
        dRow[in->PDelay1Off+i] = row->PDelay1[i];
    } 
  if (in->numPol>=1)
    if (in->GDelay1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->GDelay1Col]; i++) 
        dRow[in->GDelay1Off+i] = row->GDelay1[i];
    } 
  if (in->numPol>=1)
    if (in->PRate1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PRate1Col]; i++) 
        dRow[in->PRate1Off+i] = row->PRate1[i];
    } 
  if (in->numPol>=1)
    if (in->GRate1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->GRate1Col]; i++) 
        dRow[in->GRate1Off+i] = row->GRate1[i];
    } 
  if (in->numPol>=1) fRow[in->Disp1Off] = row->Disp1;
  if (in->numPol>=1) fRow[in->DRate1Off] = row->DRate1;
  if (in->numPol>=2)
    if (in->PDelay2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PDelay2Col]; i++) 
        dRow[in->PDelay2Off+i] = row->PDelay2[i];
    } 
  if (in->numPol>=2)
    if (in->GDelay2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->GDelay2Col]; i++) 
        dRow[in->GDelay2Off+i] = row->GDelay2[i];
    } 
  if (in->numPol>=2)
    if (in->PRate2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PRate2Col]; i++) 
        dRow[in->PRate2Off+i] = row->PRate2[i];
    } 
  if (in->numPol>=2)
    if (in->GRate2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->GRate2Col]; i++) 
        dRow[in->GRate2Off+i] = row->GRate2[i];
    } 
  if (in->numPol>=2) fRow[in->Disp2Off] = row->Disp2;
  if (in->numPol>=2) fRow[in->DRate2Off] = row->DRate2;

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iIMRow */
  retCode = ObitTableWrite ((ObitTable*)in, iIMRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableIMWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIMClose (ObitTableIM *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableIMClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableIMDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableIMClose */

/*---------------Private functions--------------------------*/
/*----------------  TableIM Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIMRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIMRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->FreqVar = NULL;
  in->PDelay1 = NULL;
  in->GDelay1 = NULL;
  in->PRate1 = NULL;
  in->GRate1 = NULL;
  in->PDelay2 = NULL;
  in->GDelay2 = NULL;
  in->PRate2 = NULL;
  in->GRate2 = NULL;

} /* end ObitTableIMRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIMRow* cast to an Obit*.
 */
void ObitTableIMRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIMRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIMRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIMRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableIMRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIMRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIMRowClassInfoDefFn (gpointer inClass)
{
  ObitTableIMRowClassInfo *theClass = (ObitTableIMRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIMRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIMRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIMRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableIMRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableIMRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableIMRowInit;

} /* end ObitTableIMRowClassDefFn */

/*------------------  TableIM  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIMInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIM *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableIMInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIM* cast to an Obit*.
 */
void ObitTableIMClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIM *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIMClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIMClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableIMClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIMClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIMClassInfoDefFn (gpointer inClass)
{
  ObitTableIMClassInfo *theClass = (ObitTableIMClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIMClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIMClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIMGetClass;
  theClass->newObit       = (newObitFP)newObitTableIM;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableIMCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableIMClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableIMInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableIMConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableIMOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableIMClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableIMReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableIMWriteRow;

} /* end ObitTableIMClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIMUpdate (ObitTableIM *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   union ObitInfoListEquiv InfoReal; 

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* RefDate */
  strncpy (in->RefDate, "YYYY-MM-DD", MAXKEYCHARTABLEIM); 
  ObitInfoListGetTest(in->myDesc->info, "RDATE", &type, dim, 
		       (gpointer)&in->RefDate);
   /* numPol */
  if (!ObitInfoListGet(in->myDesc->info, "NO_POL", &type, dim, 
		       (gpointer)&in->numPol, err)) return;
   /* obscode */
  strncpy (in->obscode, "AA000", MAXKEYCHARTABLEIM); 
  ObitInfoListGetTest(in->myDesc->info, "OBSCODE", &type, dim, 
		       (gpointer)&in->obscode);
   /* numStkd */
  if (!ObitInfoListGet(in->myDesc->info, "NO_STKD", &type, dim, 
		       (gpointer)&in->numStkd, err)) return;
   /* numBand */
  if (!ObitInfoListGet(in->myDesc->info, "NO_BAND", &type, dim, 
		       (gpointer)&in->numBand, err)) return;
   /* numChan */
  if (!ObitInfoListGet(in->myDesc->info, "NO_CHAN", &type, dim, 
		       (gpointer)&in->numChan, err)) return;
   /* refFreq */
  if (!ObitInfoListGet(in->myDesc->info, "REF_FREQ", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->refFreq = InfoReal.dbl;
  if (type==OBIT_float)  in->refFreq = InfoReal.flt;
   /* chanBW */
  if (!ObitInfoListGet(in->myDesc->info, "CHAN_BW", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->chanBW = InfoReal.dbl;
  if (type==OBIT_float)  in->chanBW = InfoReal.flt;
   /* refPixl */
  if (!ObitInfoListGet(in->myDesc->info, "REF_PIXL", &type, dim, 
		       (gpointer)&InfoReal, err)) return;
  if (type==OBIT_double) in->refPixl = InfoReal.dbl;
  if (type==OBIT_float)  in->refPixl = InfoReal.flt;
   /* npoly */
  if (!ObitInfoListGet(in->myDesc->info, "NPOLY", &type, dim, 
		       (gpointer)&in->npoly, err)) return;
   /* tabrev */
  in->tabrev = 2; 
  ObitInfoListGetTest(in->myDesc->info, "TABREV", &type, dim, 
		       (gpointer)&in->tabrev);
  in->revision = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "REVISION", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->revision = InfoReal.dbl;
  if (type==OBIT_float)  in->revision = InfoReal.flt;

  /* initialize column numbers/offsets */
  in->TimeOff = -1;
  in->TimeCol = -1;
  in->TimeIOff = -1;
  in->TimeICol = -1;
  in->SourIDOff = -1;
  in->SourIDCol = -1;
  in->antennaNoOff = -1;
  in->antennaNoCol = -1;
  in->ArrayOff = -1;
  in->ArrayCol = -1;
  in->FreqIDOff = -1;
  in->FreqIDCol = -1;
  in->IFROff = -1;
  in->IFRCol = -1;
  in->FreqVarOff = -1;
  in->FreqVarCol = -1;
  in->PDelay1Off = -1;
  in->PDelay1Col = -1;
  in->GDelay1Off = -1;
  in->GDelay1Col = -1;
  in->PRate1Off = -1;
  in->PRate1Col = -1;
  in->GRate1Off = -1;
  in->GRate1Col = -1;
  in->Disp1Off = -1;
  in->Disp1Col = -1;
  in->DRate1Off = -1;
  in->DRate1Col = -1;
  in->PDelay2Off = -1;
  in->PDelay2Col = -1;
  in->GDelay2Off = -1;
  in->GDelay2Col = -1;
  in->PRate2Off = -1;
  in->PRate2Col = -1;
  in->GRate2Off = -1;
  in->GRate2Col = -1;
  in->Disp2Off = -1;
  in->Disp2Col = -1;
  in->DRate2Off = -1;
  in->DRate2Col = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "TIME    ", 8)) {
	 in->TimeOff = desc->offset[i];
 	 in->TimeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TIME_INTERVAL ", 14)) {
	 in->TimeIOff = desc->offset[i];
 	 in->TimeICol = i;
      }
      if (!strncmp (desc->FieldName[i], "SOURCE_ID  ", 11)) {
	 in->SourIDOff = desc->offset[i];
 	 in->SourIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ANTENNA_NO", 10)) {
	 in->antennaNoOff = desc->offset[i];
 	 in->antennaNoCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ARRAY      ", 11)) {
	 in->ArrayOff = desc->offset[i];
 	 in->ArrayCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQID", 6)) {
	 in->FreqIDOff = desc->offset[i];
 	 in->FreqIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "I.FAR.ROT", 9)) {
	 in->IFROff = desc->offset[i];
 	 in->IFRCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQ.VAR", 8)) {
	 in->FreqVarOff = desc->offset[i];
 	 in->FreqVarCol = i;
      }
      if (!strncmp (desc->FieldName[i], "PDELAY_1", 8)) {
	     in->PDelay1Off = desc->offset[i];
 	     in->PDelay1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "GDELAY_1", 8)) {
	     in->GDelay1Off = desc->offset[i];
 	     in->GDelay1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "PRATE_1", 7)) {
	     in->PRate1Off = desc->offset[i];
 	     in->PRate1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "GRATE_1", 7)) {
	     in->GRate1Off = desc->offset[i];
 	     in->GRate1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DISP_1", 6)) {
	     in->Disp1Off = desc->offset[i];
 	     in->Disp1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DDISP_1", 7)) {
	     in->DRate1Off = desc->offset[i];
 	     in->DRate1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "PDELAY_2", 8)) {
	     in->PDelay2Off = desc->offset[i];
 	     in->PDelay2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "GDELAY_2", 8)) {
	     in->GDelay2Off = desc->offset[i];
 	     in->GDelay2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "PRATE_2", 7)) {
	     in->PRate2Off = desc->offset[i];
 	     in->PRate2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "GRATE_2", 7)) {
	     in->GRate2Off = desc->offset[i];
 	     in->GRate2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DISP_2", 6)) {
	     in->Disp2Off = desc->offset[i];
 	     in->Disp2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "DDISP_2", 7)) {
	     in->DRate2Off = desc->offset[i];
 	     in->DRate2Col = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->TimeOff > -1), err,
       "ObitTableIMUpdate: Could not find column Time");
  Obit_return_if_fail((in->TimeIOff > -1), err,
       "ObitTableIMUpdate: Could not find column TimeI");
  Obit_return_if_fail((in->SourIDOff > -1), err,
       "ObitTableIMUpdate: Could not find column SourID");
  Obit_return_if_fail((in->antennaNoOff > -1), err,
       "ObitTableIMUpdate: Could not find column antennaNo");
  Obit_return_if_fail((in->ArrayOff > -1), err,
       "ObitTableIMUpdate: Could not find column Array");
  Obit_return_if_fail((in->FreqIDOff > -1), err,
       "ObitTableIMUpdate: Could not find column FreqID");
  Obit_return_if_fail((in->IFROff > -1), err,
       "ObitTableIMUpdate: Could not find column IFR");
  Obit_return_if_fail((in->FreqVarOff > -1), err,
       "ObitTableIMUpdate: Could not find column FreqVar");
  if (in->numPol>=1) {
    Obit_return_if_fail((in->PDelay1Off > -1), err,
       "ObitTableIMUpdate: Could not find column PDelay1");
    Obit_return_if_fail((in->GDelay1Off > -1), err,
       "ObitTableIMUpdate: Could not find column GDelay1");
    Obit_return_if_fail((in->PRate1Off > -1), err,
       "ObitTableIMUpdate: Could not find column PRate1");
    Obit_return_if_fail((in->GRate1Off > -1), err,
       "ObitTableIMUpdate: Could not find column GRate1");
    Obit_return_if_fail((in->Disp1Off > -1), err,
       "ObitTableIMUpdate: Could not find column Disp1");
  } /* end of if index in range */
  if (in->numPol>=2) {
    Obit_return_if_fail((in->PDelay2Off > -1), err,
       "ObitTableIMUpdate: Could not find column PDelay2");
    Obit_return_if_fail((in->GDelay2Off > -1), err,
       "ObitTableIMUpdate: Could not find column GDelay2");
    Obit_return_if_fail((in->PRate2Off > -1), err,
       "ObitTableIMUpdate: Could not find column PRate2");
    Obit_return_if_fail((in->GRate2Off > -1), err,
       "ObitTableIMUpdate: Could not find column GRate2");
    Obit_return_if_fail((in->Disp2Off > -1), err,
       "ObitTableIMUpdate: Could not find column Disp2");
  } /* end of if index in range */
} /* end ObitTableIMUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIMDumpKey (ObitTableIM *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
  else info = in->myDesc->info;
  /* RefDate */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIM;
  ObitInfoListAlwaysPut(info, "RDATE", type, dim, 
		  (gpointer)&in->RefDate);
  /* numPol */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_POL", type, dim, 
		  (gpointer)&in->numPol);
  /* obscode */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIM;
  ObitInfoListAlwaysPut(info, "OBSCODE", type, dim, 
		  (gpointer)&in->obscode);
  /* numStkd */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_STKD", type, dim, 
		  (gpointer)&in->numStkd);
  /* numBand */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_BAND", type, dim, 
		  (gpointer)&in->numBand);
  /* numChan */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_CHAN", type, dim, 
		  (gpointer)&in->numChan);
  /* refFreq */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_FREQ", type, dim, 
		  (gpointer)&in->refFreq);
  /* chanBW */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CHAN_BW", type, dim, 
		  (gpointer)&in->chanBW);
  /* refPixl */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_PIXL", type, dim, 
		  (gpointer)&in->refPixl);
  /* npoly */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NPOLY", type, dim, 
		  (gpointer)&in->npoly);
  /* tabrev */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TABREV", type, dim, 
		  (gpointer)&in->tabrev);
  /* revision */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REVISION", type, dim, 
		  (gpointer)&in->revision);
   
} /* end ObitTableIMDumpKey */
